// -----------------------------------------------------------------------------
// COPYRIGHT (C) 2020 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 26 Oct, 2020 
//
// THIS FILE IS A PART OF LSF_Toolbox 
// -----------------------------------------------------------------------------


function ChooseIntMethod(handles)
	[x,y] =  Data()
	n = size(x)(1)
	if n==1 then
		messagebox("Fitting is not possible please enter more data points ", "Error!!", "error");
		return;
	end
	X = linspace(min(x),max(x),1000)
	value = handles.ChooseIntMethod.value
	select value
	case 1 then
		Y = interp1(x, y, X, "linear");
		plot(x,y,"k.",X,Y,"g","thickness",3);
		LegStr = "Linear Interpolation";
		LabelGraph(handles, LegStr, 2);
		InsertTable(handles,"Linear Interpolation", 0,1, 0, %nan,%nan, n)
	case 2 then
		Y = interp1(x, y, X, "spline");
		plot(x,y,"k.",X,Y,"g","thickness",3);
		LegStr = "Spline Interpolation";
		LabelGraph(handles, LegStr, 2);
		InsertTable(handles,"Spline Interpolation", 0,1, 0, %nan,%nan, n)
	case 3 then
		Y = interp1(x, y, X, "nearest");
		plot(x,y,"k.",X,Y,"g","thickness",3);
		LegStr = "Nearest neighbour Interpolation";
		LabelGraph(handles, LegStr, 2);
		InsertTable(handles,"Nearest neighbour Interpolation", 0,1, 0, %nan,%nan, n)
	else
		error("Error")
	end 
endfunction
