// -----------------------------------------------------------------------------
// COPYRIGHT (C) 2020 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 26 Oct, 2020 
//
// THIS FILE IS A PART OF LSF_Toolbox 
// -----------------------------------------------------------------------------


// THIS FUNCTION WILL CLEAR/RESET THE GRAPH
function LabelGraph(handles, LegStr, Pos)
	if handles.SelectChoose.value == 0
		xlabel('$\bold{X ---->}$',"fontsize",3,"color","black")
		ylabel('$ \bold{Y ---->}$',"fontsize",3,"color","black")
		legxy = "x vs. y";
	else
		ypos = handles.ChooseY.value; 
		yvar = handles.ChooseY.string(ypos);
		xpos = handles.ChooseX.value;
		xvar = handles.ChooseX.string(xpos);
		legxy = yvar + " vs. " + xvar;
		xlabel(xvar,"fontsize",4,"color","black")
		ylabel(yvar,"fontsize",4,"color","black")
	end
	
	title("Least Square Fitting","fontsize",4,"color","black")
	mm = gca()
	mm.font_color = 5
	mm.foreground = 2
	mm.font_size = 3
	handles.menu_5.enable = 'on'
	handles.menu_1.enable = 'on'
	handles.menu_2.enable = 'on'
	xgrid(1,1,7);
	handles.leg = legend( [legxy,LegStr], Pos)
	v = handles.Plot;
	l = v.children(1);
	if handles.menu_5.label=="Hide Legend |"
		l.visible = 'on';
	else
		l.visible = 'off';
	end
endfunction
