// -----------------------------------------------------------------------------
// COPYRIGHT (C) 2020 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 26 Oct, 2020 
//
// THIS FILE IS A PART OF LSF_Toolbox 
// -----------------------------------------------------------------------------


function leastsqr()
	// ============================ Main Figure =================================
	f = figure("figure_position",[150,20],...
	"figure_size",[1100,820],...
	"auto_resize","on",...
	"background",[33],...
	"figure_name","Leat Square Fitting",....
	"dockable","on",...
	"infobar_visible","off",...
	"toolbar_visible","off",...
	"menubar_visible","on",...
	"default_axes","off",....
	"visible","off",...
	"menubar","none");

	//////////
	handles.dummy = 0;
	IconPath = atomsGetInstalledPath(["LSF_Toolbox","2.0.0"]) + "\icons";
	// ================================ Menu ====================================

	// Menu for Grid on and off
	handles.menu_1 = uimenu(f,...
	"icon",IconPath+"\grid.png",...
	"callback","Grid(handles)",...
	"Enable","off",...
	"label","grid on |");
	//Menu for Labling the graph (xlabel,ylabel,title)
	handles.menu_2 = uimenu(f,...
	"icon",IconPath+"\label.png",...
	"callback","Label(handles)",...
	"Enable","off",...
	"label","label |");

	handles.menu_5 = uimenu(f,...
	"icon",IconPath+"\label.png",...
	"callback","Leg(handles)",...
	"Enable","off",...
	"label","Hide Legend |");

	//Menu for Help ( help(leastsqr) )
	handles.menu_3 = uimenu(f,...
	"icon",IconPath+"\help.png",...
	"callback","help",...
	"label","help |");
	//Menu for Print ( Print() )
	handles.menu_4 = uimenu(f,...
	"icon",IconPath+"\print.png",...
	"callback","Print(handles)",...
	"label","Print Fig");

	// ============================= Frames ======================================

	handles.InputFrame = uicontrol(f,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Position",[0,0,0.30,1],...
	"Relief","sunken",...
	"Style","frame");
	handles.OutputFrame = uicontrol(f,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Position",[0.30,0.20,0.70,0.76],...
	"Relief","sunken",...
	"Style","frame");
	handles.ResultFrame = uicontrol(handles.InputFrame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Position",[0.01,0,0.98,0.29],...
	"Relief","sunken",...
	"Style","frame");

	handles.Choose_Frame = uicontrol(handles.InputFrame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Position",[0.01,0.51,0.98,0.13],...
	"Relief","sunken",...
	"Style","frame");

	handles.Btn_Frame = uicontrol(handles.InputFrame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Position",[0.01,0.3,0.98,0.2],...
	"Relief","sunken",...
	"Style","frame");

	// ======================== Inside Input Frame ===============================

	//                            ---- Table ----                                 
	handles.TableTitle = uicontrol(handles.InputFrame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.6,0.95],...
	"HorizontalAlignment","left",...
	"Position",[0.01,0.96,0.98,0.035],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"String","Enter The Data Points You Want To Fit:",...
	"Style","text");
	handles.DataTabel = uicontrol(handles.InputFrame,...
	"unit","normalized",...
	"Position",[0.01,0.68,0.98,0.28],...
	"Relief","sunken",...
	"String","",...
	"Style","table");
	// Choose Frame Title
	handles.CooseTitle = uicontrol(handles.InputFrame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.6,0.95],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"HorizontalAlignment","left",...
	"Position",[0.01,0.64,0.98,0.039],...
	"String","Or Select Data : ",...
	"Style","text")

	// ------------------------- Inside Choose_Frame -----------------------------

	handles.SelectChoose = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.01,0.7,0.98,0.2],...
	"String","Choose data from variable browser",...
	"Style","radiobutton",...
	"Callback","Choose_Callback(handles)");
	handles.ChooseXText = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.02,0.4,0.2,0.2],...
	"String","X Data :",...
	"Style","text");
	handles.ChooseX = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"Enable","off",...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.24,0.4,0.55,0.2],...
	"String","",...
	"Style","popupmenu",...
	"value", 0, ...
	"Callback","ChooseX_Callback(handles)");
	handles.XSizeText = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.8,0.4,0.19,0.2],...
	"String","",...
	"Style","text");
	handles.ChooseYText = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.02,0.1,0.2,0.2],...
	"String","Y Data :",...
	"Style","text");
	handles.ChooseY = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Enable","off",...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.24,0.1,0.55,0.2],...
	"String","",...
	"Style","popupmenu",...
	"value", 0, ...
	"Callback","ChooseY_Callback(handles)");
	handles.YSizeText = uicontrol(handles.Choose_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.8,0.1,0.19,0.2],...
	"String","",...
	"Style","text");

	// ------------------------- Inside Button Frame -----------------------------

	handles.ChooseMethod = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.1,0.4,0.1],...
	"Enable","on",...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.02,0.75,0.96,0.2],...
	"string",["Linear","Polynomial","Exponential","Power","Interpolation","Smooth Spline"],...
	"value",1,...
	"Style","popupmenu",...
	"Callback","ChooseMethod(handles)");
	handles.PolyOrderText = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.02,0.50,0.4,0.2],...
	"String","Order of Polynomial :",...
	"Style","text",...
	"visible","off");
	handles.PolyOrderEntry = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.41,0.50,0.57,0.2],...
	"HorizontalAlignment","center",...
	"Relief","sunken",...
	"String","2",...
	"Style","edit",...
	"Callback","ChooseMethod(handles)",...
	"visible","off");
	handles.ChooseIntText = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.02,0.50,0.2,0.2],...
	"String","Method :",...
	"Style","text",...
	"visible","off");
	handles.ChooseIntMethod = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.8,0.8],...
	"Enable","on",...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.21,0.50,0.77,0.2],...
	"string",["Linear","Cubic Spline","Nearest neighbor"],...
	"value",1,...
	"Style","popupmenu",...
	"Callback","ChooseIntMethod(handles)",...
	"visible","off");
	handles.ClearResultsBtn = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.9,0.5,0.4],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.06,0.05,0.3,0.2],...
	"Relief","raised",...
	"String","Clear Results",...
	"Style","pushbutton",...
	"Callback","ClearResults(handles)");
	handles.FitBtn = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.7,0.8,0.4],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.71,0.05,0.25,0.2],...
	"Relief","raised",...
	"String","Fit",...
	"Style","pushbutton",...
	"Callback","ChooseMethod(handles)");
	handles.ClearDataBtn = uicontrol(handles.Btn_Frame,...
	"unit","normalized",...
	"BackgroundColor",[0.9,0.3,0.1],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"Position",[0.41,0.05,0.25,0.2],...
	"Relief","raised",...
	"String","Clear Data",...
	"Style","pushbutton",...
	"Callback","ClearData(handles)");

	// ======================= Inside Output Frame ===============================

	handles.PlotTitle = uicontrol(f,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.6,0.95],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"HorizontalAlignment","left",...
	"Position",[0.301,0.962,0.698,0.035],...
	"String"," Plot : ",...
	"Style","text")
	// Axes
	handles.Plot = newaxes(handles.OutputFrame);...
	handles.Plot.auto_clear = "on";

	//                            ---- Table of Fits ----                                 
	handles.FTableTitle = uicontrol(f,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.6,0.95],...
	"HorizontalAlignment","left",...
	"Position",[0.301,0.15,0.698,0.05],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"String","Table of Fits:",...
	"Style","text");
	handles.FitTabel = uicontrol(f,...
	"unit","normalized",...
	"Position",[0.301,0.01,0.698,0.15],...
	"Relief","sunken",...
	"String","",...
	"Style","table");
	handles.FitTabel.string = [["","Data","Fit Type","SSE","R^2", "DFE", "Adj. R^2", "RMSE", "# Coeff"]; ["1","","","","","","", "",""]]
	// ======================= Inside Result Frame ===============================
	handles.ResultTitle = uicontrol(handles.ResultFrame,...
	"unit","normalized",...
	"BackgroundColor",[0.8,0.6,0.95],...
	"FontName","Tahoma",...
	"FontSize",[12],...
	"HorizontalAlignment","left",...
	"Position",[0.01,0.88,0.99,0.12],...
	"String","Results : ",...
	"Style","text")
	handles.ResultTitle.Userdata = [];
	handles.Result_Text = uicontrol(handles.ResultFrame,...
	"unit","normalized",...
	"BackgroundColor",[1,1,1],...
	"ForegroundColor",[-1,-1,-1],..
	"FontName","Tahoma",...
	"FontSize",[12],...
	"FontWeight","normal",...
	"Max",[2],...
	"Position",[0,0.005,1,0.87],...
	"HorizontalAlignment","left",...
	"VerticalAlignment","top",...
	"Enable","on",...
	"String"," ",...
	"Userdata"," ",...
	"scrollable","on",...
	"Relief", "sunken",...
	"Margins",[50,50,50,50], ...
	"Style","edit");
	f.visible = 'on'
	[f,handles] = resume(f,handles);
	ClearData(handles);
endfunction
